Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1289970

Summary: Review Request: python-openstacksdk - An SDK for building applications to work with OpenStack
Product: [Fedora] Fedora Reporter: Javier Peña <jpena>
Component: Package ReviewAssignee: Zbigniew Jędrzejewski-Szmek <zbyszek>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: apevec, dmsimard, hguemar, pabelanger, package-review, panemade, zbyszek
Target Milestone: ---Flags: zbyszek: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2016-04-08 09:24:07 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1314401    
Bug Blocks: 1290163    

Description Javier Peña 2015-12-09 12:43:55 UTC
Spec URL: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk.spec
SRPM URL: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk-0.7.1-1.fc24.src.rpm
Description: A collection of libraries for building applications to work with OpenStack clouds.
Fedora Account System Username: jpena

Koji scratch build available at http://koji.fedoraproject.org/koji/taskinfo?taskID=12124583

Comment 1 Upstream Release Monitoring 2015-12-10 09:38:00 UTC
jpena's scratch build of python-openstacksdk-0.7.1-2.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12135967

Comment 3 Paul Belanger 2015-12-17 18:01:34 UTC
Learning the ropes, so here is a review.  Only major thing was a few lint warnings.  Plus the failures reported my fedora-review.

All in all, looks good.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[ ]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.5/site-packages,
     /usr/lib/python3.5
[ ]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.5/site-
     packages, /usr/lib/python3.5
[ ]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/python2.7/site-
     packages/openstack(python-openstack-nose-plugin)
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-openstacksdk , python2-openstacksdk-tests ,
     python3-openstacksdk , python3-openstacksdk-tests , python-
     openstacksdk-doc
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-openstacksdk-0.7.1-2.fc24.noarch.rpm
          python2-openstacksdk-tests-0.7.1-2.fc24.noarch.rpm
          python3-openstacksdk-0.7.1-2.fc24.noarch.rpm
          python3-openstacksdk-tests-0.7.1-2.fc24.noarch.rpm
          python-openstacksdk-doc-0.7.1-2.fc24.noarch.rpm
          python-openstacksdk-0.7.1-2.fc24.src.rpm
python2-openstacksdk-tests.noarch: W: no-documentation
python3-openstacksdk-tests.noarch: W: no-documentation
6 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
python2-openstacksdk-tests.noarch: W: no-documentation
python3-openstacksdk-tests.noarch: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
python3-openstacksdk (rpmlib, GLIBC filtered):
    python(abi)
    python3-keystoneauth1
    python3-os-client-config
    python3-oslo-utils
    python3-six
    python3-stevedore

python2-openstacksdk-tests (rpmlib, GLIBC filtered):
    python(abi)
    python2-openstacksdk

python3-openstacksdk-tests (rpmlib, GLIBC filtered):
    python(abi)
    python3-openstacksdk

python2-openstacksdk (rpmlib, GLIBC filtered):
    python(abi)
    python-keystoneauth1
    python-os-client-config
    python-oslo-utils
    python-six
    python-stevedore

python-openstacksdk-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-openstacksdk:
    python3-openstacksdk

python2-openstacksdk-tests:
    python2-openstacksdk-tests

python3-openstacksdk-tests:
    python3-openstacksdk-tests

python2-openstacksdk:
    python-openstacksdk
    python-openstacksdk(x86-64)
    python2-openstacksdk

python-openstacksdk-doc:
    python-openstacksdk-doc



Source checksums
----------------
https://pypi.python.org/packages/source/o/openstacksdk/openstacksdk-0.7.1.tar.gz :
  CHECKSUM(SHA256) this package     : 620b4303a2742e17605427772e6468cb59bb36ee3ca74b41aeec2226e06fc842
  CHECKSUM(SHA256) upstream package : 620b4303a2742e17605427772e6468cb59bb36ee3ca74b41aeec2226e06fc842


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1289970 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 4 Javier Peña 2015-12-18 13:35:40 UTC
Thanks for the review Paul. The rpmlint messages are expected, all but two are related to python3.5 compiled files, and the remaining two state no documentation in the -tests subpackages, which depend on the base packages so there is documentation already.

Also, the fully versioned dependencies note is expected, the -doc subpackage should not depend on anything, and the -tests subpackages already depend on their base packages, so I'd say it is correct.

I have uploaded a new version (with minor corrections):

SPEC: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk.spec
SRPM: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk-0.7.1-3.fc24.src.rpm

I see there is a newer 0.7.3 version available upstream, but this one depends on openstackdocstheme, which is not packaged yet and has sparked some concerns in the community (due to external resources being loaded and usage by default of Google Analytics).

Comment 5 hguemar 2016-02-24 10:55:54 UTC
Missing BR to python-setuptools, this is important as it causes build failures on EL. It's a known issue but Fedora buildroot includes it, hence no build failures.

Comment 6 Javier Peña 2016-02-24 16:19:26 UTC
Thanks Haikel, I've fixed that. Updated files:

SPEC: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk.spec
SRPM: https://jpena.fedorapeople.org/python-openstacksdk/python-openstacksdk-0.7.1-4.fc24.src.rpm

Still using the older 0.7.1 version because of the dependency on openstackdocstheme.

Comment 7 Upstream Release Monitoring 2016-02-24 16:41:56 UTC
jpena's scratch build of python-openstacksdk-0.7.1-4.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=13115129

Comment 8 Upstream Release Monitoring 2016-02-24 16:53:47 UTC
jpena's scratch build of python-openstacksdk-0.7.1-4.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=13115228

Comment 9 Zbigniew Jędrzejewski-Szmek 2016-02-28 01:36:03 UTC
You don't need to repeat the Summary text. After the first instance you can refer the the previous one with %{summary}. And for tests you you can use "Summary: %{summary} - test files".

Also, "An " in the summary is not useful, listings look better without the article.

Very nice package.

+ license is acceptable (ASL 2)
+ license file is present, %license is used
- not the latest version (0.7.4 is latest on pypi)
+ no scriptlets
+ %check is present and passes
+ rpmlint is happy (only no-documentation warning)
+ provides and requires seem right

Package is APPROVED.

Please update to the latest version.

Comment 10 Javier Peña 2016-03-01 15:31:38 UTC
(In reply to Zbigniew Jędrzejewski-Szmek from comment #9)
> You don't need to repeat the Summary text. After the first instance you can
> refer the the previous one with %{summary}. And for tests you you can use
> "Summary: %{summary} - test files".
> 
> Also, "An " in the summary is not useful, listings look better without the
> article.
> 
> Very nice package.
> 
> + license is acceptable (ASL 2)
> + license file is present, %license is used
> - not the latest version (0.7.4 is latest on pypi)
> + no scriptlets
> + %check is present and passes
> + rpmlint is happy (only no-documentation warning)
> + provides and requires seem right
> 
> Package is APPROVED.
> 
> Please update to the latest version.

About the latest version, it introduces a dependency on openstackdocstheme, which is not packaged yet. I remember there were some concerns due to its usage of Google Analytics and the fact it includes files from external references. Should I go ahead and get a package review for that dependency first?

Comment 11 Zbigniew Jędrzejewski-Szmek 2016-03-01 15:42:09 UTC
I think packaging openstackdocstheme would be the way forward. After all, staying on an old version of openstacksdk is not attractive.

Commit https://review.openstack.org/#/c/253592/ in openstackdocstheme seems to avoid the issue of google analytics. I think you should patch the config file in Fedora to have it off by default.

If you decide to add openstackdocstheme, I'm happy to review. Please add me in CC.

Comment 12 Gwyn Ciesla 2016-03-04 14:10:37 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python-openstacksdk

Comment 13 Mike McCune 2016-03-28 23:47:57 UTC
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune with any questions